import { CPCWallet, BigNumber, CPCJsonRpcProvider, Contract, TxResult, uint256, address, uint8 } from 'cpchain-typescript-sdk';
export interface Transfer {
    from: address;
    to: address;
    value: uint256;
}
export interface Approval {
    owner: address;
    spender: address;
    value: uint256;
}
export declare class ERC20Viewer {
    provider: CPCJsonRpcProvider;
    contractAddress: address;
    contract: Contract;
    constructor(provider: CPCJsonRpcProvider, contractAddress: address);
    name(): Promise<[string]>;
    symbol(): Promise<[string]>;
    decimals(): Promise<[uint8]>;
    totalSupply(): Promise<[uint256]>;
    balanceOf(account: address): Promise<[uint256]>;
    allowance(owner: address, spender: address): Promise<[uint256]>;
}
export declare class ERC20Caller {
    wallet: CPCWallet;
    contractAddress: address;
    contract: Contract;
    constructor(wallet: CPCWallet, contractAddress: address);
    transfer(recipient: address, amount: uint256, _tx?: {
        value?: BigNumber;
    }): Promise<TxResult>;
    approve(spender: address, value: uint256, _tx?: {
        value?: BigNumber;
    }): Promise<TxResult>;
    transferFrom(sender: address, recipient: address, amount: uint256, _tx?: {
        value?: BigNumber;
    }): Promise<TxResult>;
    increaseAllowance(spender: address, addedValue: uint256, _tx?: {
        value?: BigNumber;
    }): Promise<TxResult>;
    decreaseAllowance(spender: address, subtractedValue: uint256, _tx?: {
        value?: BigNumber;
    }): Promise<TxResult>;
}
